;;; +chicken.el --- Chicken Scheme additions -*- lexical-binding: t; -*-

;;; Commentary:

;;; Code:

;; Reload [[https://wiki.call-cc.org/eggref/5/awful][awful]] with a keybinding

(defun +chicken-awful-reload ()
  "Reload awful by visiting /reload."
  (interactive)
  (save-buffer)
  (condition-case e
      (url-retrieve-synchronously "http://localhost:8080/reload")
    (file-error (progn
                  (message "Couldn't ping awful's server.  Starting...")
                  (start-process "awful" (generate-new-buffer "*awful*")
                                 "awful" "--development-mode" (buffer-file-name))))
    (t (message "Some awful error occurred!"))))

(provide '+chicken)
;;; +chicken.el ends here
